class Object extends nil {
function inspect() {
  StringInspector.open(this.tostring());
}
function isnil() {
  return 1 == 0;
}
function notnil() {
  return 1 == 1;
}
primitive tostring() {
  "object tostring"
}
}
class Behavior extends Object {
var instanceVariables, methodDict, superclass;
}
class Class extends Behavior {
var name, subclasses;
}
class MetaClass extends Behavior {
var thisClass;
}
class Boolean extends Object {
}
class False extends Boolean {
}
class True extends Boolean {
}
class Collections extends Object {
}
class Array extends Collections {
static primitive create(n) {
    "varray .ctor int"
  }
static primitive fromArray(array) {
  "varray .ctor object[]"
}
primitive at(n) {
  "varray at int32"
}
primitive atPut(n,val) {
  "varray atput int32 object"
}
function inspect() {
  ArrayInspector.open(this);
}
primitive length() {
  "varray length"
}
}
class Dictionary extends Collections {
static primitive create() {
  "vdictionary .ctor"
}
primitive at(objkey) {
  "vdictionary at object"
}
primitive atPut(objkey, objval) {
  "vdictionary atput object object"
}
function inspect() {
  DictionaryInspector.open(this);
}
primitive keys() {
  "vdictionary keys"
}
primitive length() {
  "vdictionary length"
}
primitive removeat(objkey) {
  "vdictionary removeat object"
}
}
class List extends Collections {
static primitive create() {
  "vlist .ctor"
}
static primitive create(array) {
  "vlist .ctor object[]"
}
primitive add(obj) {
  "vlist add object"
}
primitive at(n) {
  "vlist at int32"
}
primitive atPut(n,val) {
  "vlist atput int32 object"
}
function inspect() {
  ListInspector.open(this);
}
primitive length() {
  "vlist length"
}
primitive removeat(n) {
  "vlist removeat int32"
}
primitive toarray() {
  "vlist toarray"
}
primitive toArrayOfType(t) {
  "vlist toarrayoftype string"
}
}
class Console extends Object maps System.Console {
static primitive print(anObject) {
  "vm print object"
}
static primitive println(anObject) {
  "vm println object"
}
}
class Context extends Object {
}
class Block extends Context {
}
class MethodContext extends Context {
}
class LispStream extends Object {
}
class Magnitude extends Object {
}
class Number extends Magnitude {
}
class Decimal extends Number {
}
class Integer extends Number {
}
class Mapped extends Object {
}
class ArrangedElementCollection extends Mapped {
primitive count() {
  "arrangedelementcollection count"
}
}
class ControlControlCollection extends ArrangedElementCollection {
}
class FormControlCollection extends ControlControlCollection maps System.Windows.Forms.Form+ControlCollection {
primitive add(aControl) {
  "form+controlcollection add control"
}
}
class ComboBoxObjectCollection extends Mapped maps System.Windows.Forms.ComboBox+ObjectCollection {
primitive add(anObject) {
  "combobox+objectcollection add object"
}
primitive clear() {
  "combobox+objectcollection clear"
}
}
class ContentControl extends Mapped {
}
class XamlWindow extends ContentControl {
static primitive create() {
  "system.windows.window .ctor"
}
primitive show() {
  "system.windows.window show"
}
primitive showdialog() {
  "system.windows.window showdialog"
}
}
class Control extends Mapped {
primitive anchor(n) {
  "control anchor anchorstyles"
}
primitive controls() {
  "control controls"
}
primitive height() {
  "control height"
}
primitive height(n) {
  "control height int32"
}
primitive left(n) {
  "control left int32"
}
primitive text() {
  "control text"
}
primitive text(str) {
  "control text string"
}
primitive top(n) {
  "control top int32"
}
primitive width() {
  "control get_Width"
}
primitive width(n) {
  "control set_Width int32"
}
}
class ButtonBase extends Control {
primitive text(str) {
  "buttonbase text string"
}
}
class Button extends ButtonBase maps System.Windows.Forms.Button {
static primitive create() {
  "button .ctor"
}
}
class CheckBox extends ButtonBase maps System.Windows.Forms.CheckBox {
static primitive create() {
  "checkbox .ctor"
}
primitive checked() {
  "checkbox get_checked"
}
primitive checked(bool) {
  "checkbox set_checked boolean"
}
}
class Form extends Control maps System.Windows.Forms.Form {
static primitive create() {
  "form .ctor"
}
primitive controls() {
  "form controls"
}
primitive show() {
  "form show"
}
primitive showdialog() {
  "form showdialog"
}
primitive text(str) {
  "form text string"
}
}
class Prompter extends Form maps Vistascript.Prompter {
static function prompt(title) {
  var val;
  val = this.promptValue(title,"");
  return val;
}
static function promptValue(title,value) {
  var p,val;
  p = this.titleValue(title,value);
  p.showdialog();
  val = p.value();
  return val;
}
static primitive titleValue(title,value) {
  "prompter .ctor string string"
}
primitive ok() {
  "prompter ok"
}
primitive value() {
  "prompter value"
}
}
class ListControl extends Control {
}
class ComboBox extends ListControl maps System.Windows.Forms.ComboBox {
static primitive create() {
  "combobox .ctor"
}
primitive findStringExact(url) {
  "combobox findstringexact string"
}
primitive items() {
  "combobox get_items"
}
primitive selectedindex() {
  "combobox get_selectedindex"
}
primitive text() {
  "combobox get_text"
}
primitive text(astring) {
  "combobox set_text string"
}
}
class ListBox extends ListControl maps System.Windows.Forms.ListBox {
static primitive create() {
  "listbox .ctor"
}
primitive items() {
  "listbox get_items"
}
primitive selectedindex() {
  "listbox get_selectedindex"
}
primitive selecteditem() {
  "listbox get_selecteditem"
}
}
class TextBoxBase extends Control {
primitive multiLine(aboolean) {
  "textboxbase multiline boolean"
}
}
class TextBox extends TextBoxBase maps System.Windows.Forms.TextBox {
static primitive create() {
  "textbox .ctor"
}
primitive text() {
    "textbox get_text"
  }
primitive text(str) {
  "textbox text string"
}
}
class WebBrowserBase extends Control {
}
class WebBrowser extends WebBrowserBase maps System.Windows.Forms.WebBrowser {
static primitive create() {
  "webbrowser .ctor"
}
primitive navigate(url) {
  "webbrowser navigate string"
}
primitive url() {
  "webbrowser get_url"
}
}
class Handler extends Mapped maps Vistascript.VHandler {
static primitive addHandler(anObject,aString,aBlock) {
  "vhandler addhandler object string vblock"
}
}
class ListBoxObjectCollection extends Mapped maps System.Windows.Forms.ListBox+ObjectCollection {
primitive add(anObject) {
  "listbox+objectcollection add object"
}
primitive clear() {
  "listbox+objectcollection clear"
}
}
class Message extends Mapped maps jabber.protocol.client.Message {
primitive body() {
  "jabber.protocol.client.Message body"
}
primitive subject() {
  "jabber.protocol.client.Message subject"
}
primitive thread() {
  "jabber.protocol.client.Message thread"
}
}
class String extends Mapped maps System.String {
static primitive concat2(obj1, obj2) {
  "string concat object object"
}
static primitive newline() {
  "environment newline"
}
primitive at(n) {
  "string get_chars int32"
}
primitive length() {
  "string length"
}
primitive split(chars) {
  "string split char[]"
}
function splitOnString(str) {
  var ch, chars, s;
  ch = str.at(0);
  chars = List.create();
  chars.add(ch);
  chars = chars.toArrayOfType("char");
  s = this.split(chars);
  return s;
}
primitive startsWith(start) {
  "string startswith string"
}
primitive substring(start) {
  "string substring int32"
}
primitive substringLen(start,len) {
  "string substring int32 int32"
}
}
class TranscriptWriter extends Mapped maps Vistascript.TranscriptWriter {
static primitive create(aTextBox) {
  "transcriptwriter .ctor textbox"
}
primitive print(anObject) {
  "transcriptwriter print object"
}
primitive println(anObject) {
  "transcriptwriter println object"
}
primitive write(aString) {
  "transcriptwriter write string"
}
primitive writeline(aString) {
  "transcriptwriter writeline string"
}
}
class Uri extends Mapped maps System.Uri {
static primitive create(str) {
  "uri .ctor string"
}
primitive absoluteuri() {
  "uri get_absoluteuri"
}
}
class Vm extends Mapped {
static primitive eval(expr) {
  "vm eval string"
}
static primitive findControlName(ctrl, name) {
  "vm findcontrol object string"
}
static primitive loadForm(path) {
  "vm loadform string"
}
static primitive loadWindow(path) {
  "vm loadwindow string"
}
static primitive newinstance(astring) {
  "vm newinstance string"
}
static primitive runapp(form) {
  "vm runapp form"
}
static primitive startupString() {
  "vm getstartupstring"
}
static primitive startupString(astring) {
  "vm setstartupstring string"
}
}
class Vs2Php extends Mapped maps Vistascript.Vs2Php {
static primitive create() {
  "vs2php .ctor"
}
primitive queryServer(str) {
  "vs2php queryserver string"
}
primitive sendToServer(str) {
  "vs2php sendtoserver string"
}
primitive url(str) {
  "vs2php set_url string"
}
}
class Vs2Vs extends Mapped maps Vistascript.Vs2Vs {
static primitive create() {
  "vs2vs .ctor"
}
primitive close() {
  "vs2vs close"
}
primitive connect() {
  "vs2vs connect"
}
primitive passwd(aString) {
  "vs2vs set_passwd string"
}
primitive sendMsg(rec,msg) {
  "vs2vs sendto string string"
}
primitive user(aString) {
  "vs2vs set_user string"
}
}
class UndefinedObject extends Object {
function isnil() {
  return 1 == 1;
}
function notnil() {
  return 1 == 0;
}
}
class Window extends Object {
var form;
function open(path) {
  form = Vm.loadForm(path);
  this.setTitle();
}
function run() {
  Vm.runapp(form);
}
function setTitle() {
  form.text(this.title());
}
function title() {
  return "Window";
}
}
class Demo extends Window {
function setTitle() {
}
}
class VsAjax extends Demo {
var clients, clist, detail, php, rentals, rlist, text;
static function open() {
  var xa;
  xa = new VsAjax();
  xa.open();
}
function clientselect() {
  var ch, chars, client, cmd, code, i, index, items, len, nl, r, s;
  index = clist.selectedindex();
  client = clients.at(index);
  code = client.at(1);
  cmd = "cmd=clientdetail&id=" + code;
  detail = php.queryServer(cmd);
  detail = detail.splitOnString(":");
  nl = String.newline();
  s = detail.at(0);
  index = 1;
  while (index < detail.length()) {
    s = s + nl + detail.at(index);
    index = index + 1;
  }
  s = s + nl;
  text.text(s);
  cmd = "cmd=clientrentals&id=" + code;
  rentals = php.queryServer(cmd);
  len = rentals.length();
  items = rlist.items();
  items.clear();
  i = 0;
  while(i < len) {
    r = rentals.at(i);
    r = r.at(0);
    items.add(r);
    i = i + 1;
  }
}
function load() {
  var i, items, len, name;
  items = clist.items();
  items.clear();
  php = Vs2Php.create();
  php.url("http://vistascript.net/vistascript/webserv/vsajax.php");
  clients = php.queryServer("cmd=clientlist");
  len = clients.length();
  i = 0;
  while (i < len) {
    name = clients.at(i);
    name = name.at(0);
    items.add(name);
    i = i + 1;
  }
}
function open() {
  var hnd;
  super.open("Scripts/Xml/vsajax.xml");
  hnd = function(){this.load();};
  Handler.addHandler(form,"Load",hnd);
  clist = Vm.findControlName(form, "listbox1");
  hnd = function(){this.clientselect();};
  Handler.addHandler(clist,"SelectedIndexChanged",hnd);
  rlist = Vm.findControlName(form, "listbox2");
  hnd = function(){this.rentalselect();};
  Handler.addHandler(rlist,"SelectedIndexChanged",hnd);
  text = Vm.findControlName(form, "textbox1");
  super.run();
}
function rentalselect() {
  var index, nl, rental, s;
  index = rlist.selectedindex();
  rental = rentals.at(index);
  nl = String.newline();
  s = rental.at(1);
  s = s + nl + rental.at(2);
  s = s + nl;
  text.text(s);
}
}
class VsBrowser extends Demo {
var browser, combobox, gobtn;
static function open() {
  var vb;
  vb = new VsBrowser();
  vb.open();
}
function go() {
  var index, items, url;
  url = combobox.text();
  browser.navigate(url);
  index = combobox.findStringExact(url);
  if (index < 0) {
    items = combobox.items();
    items.add(url);
  }
}
function load() {
  hnd = function(){this.go();};
  Handler.addHandler(gobtn,"Click",hnd);
  combobox.text("google.com");
  this.go();
}
function open() {
  var hnd;
  super.open("Scripts/Xml/vsbrowser.xml");
  browser = Vm.findControlName(form, "webbrowser1");
  combobox = Vm.findControlName(form, "combobox1");
  gobtn = Vm.findControlName(form, "button1");
  hnd = function(){this.load();};
  Handler.addHandler(form,"Load",hnd);
  super.run();
}
}
class VsChat extends Demo {
var jabberclient, trans, transcript, connected, contact, passwd, user, btn1, btn2, input;
static function open() {
  var xc;
  xc = new VsChat();
  xc.open();
}
function load() {
  var hnd;
  connected = false;
  transcript = TranscriptWriter.create(trans);
  jabberclient = Vs2Vs.create();
  hnd = function(a){this.receive(a);};
  Handler.addHandler(jabberclient,"Vs2VsEvent",hnd);
  hnd = function(){this.signinout();};
  Handler.addHandler(btn1,"Click",hnd);
  hnd = function(){this.send();};
  Handler.addHandler(btn2,"Click",hnd);
}
function open() {
  var hnd;
  super.open("Scripts/Xml/vschat.xml");
  trans = Vm.findControlName(form, "textbox1");
  input = Vm.findControlName(form, "textbox2");
  btn1 = Vm.findControlName(form, "button1");
  btn2 = Vm.findControlName(form, "button2");
  hnd = function(){this.load();};
  Handler.addHandler(form,"Load",hnd);
  super.run();
}
function receive(msg) {
  transcript.println(">> " + msg);
}
function send() {
  var txt;
  txt = input.text();
  jabberclient.sendMsg(contact, txt);
}
function signin() {
  user = Prompter.prompt("User");
  passwd= Prompter.prompt("Passwd");
  contact= Prompter.prompt("Contact");
  jabberclient.user(user);
  jabberclient.passwd(passwd);
  jabberclient.connect();
  form.text(user);
}
function signinout() {
  if (connected) {
    this.signout();
    connected = false;
    btn1.text("Signin");
  }
  else {
    this.signin();
    connected = true;
    btn1.text("Signout");
  }
}
function signout() {
  user = "";
  password = "";
  contact = "";
  form.text(user);
  jabberclient.close();
}
}
class VsWorkgroup extends Demo {
var input, jabberclient, trans, transcript, connected, contact, passwd, user, btn1, btn2, btn3, cb1, cb2, cb3, cb4;
static function open() {
  var xc;
  xc = new VsWorkgroup();
  xc.open();
}
function load() {
  var hnd;
  connected = false;
  transcript = TranscriptWriter.create(trans);
  jabberclient = Vs2Vs.create();
  hnd = function(a){this.receive(a);};
  Handler.addHandler(jabberclient,"Vs2VsEvent",hnd);
  hnd = function(){this.signinout();};
  Handler.addHandler(btn1,"Click",hnd);
  hnd = function(){this.send();};
  Handler.addHandler(btn2,"Click",hnd);
  hnd = function(){this.sendupdate();};
  Handler.addHandler(btn3,"Click",hnd);
}
function open() {
  var hnd;
  super.open("Scripts/Xml/vsworkgroup.xml");
  form = Vm.loadForm("Scripts/Xml/vsworkgroup.xml");
  trans = Vm.findControlName(form, "textbox1");
  input = Vm.findControlName(form, "textbox2");
  btn1 = Vm.findControlName(form, "button1");
  btn2 = Vm.findControlName(form, "button2");
  btn3 = Vm.findControlName(form, "button3");
  cb1 = Vm.findControlName(form, "checkbox1");
  cb2 = Vm.findControlName(form, "checkbox2");
  cb3 = Vm.findControlName(form, "checkbox3");
  cb4 = Vm.findControlName(form, "checkbox4");
  hnd = function(){this.load();};
  Handler.addHandler(form,"Load",hnd);
  super.run();
}
function receive(msg) {
  var isupdate, msg2;
  isupdate = msg.startsWith("@vistascript@");
  if (isupdate) {
    msg2 = msg.substring(13);
    this.receiveupdate(msg2);
  }
  else {
    transcript.println(">> " + msg);
  }
}
function receiveupdate(msg) {
  var array, state;
  array = Vm.eval(msg);
  state = array.at(0);
  cb1.checked(state);
  state = array.at(1);
  cb2.checked(state);
  state = array.at(2);
  cb3.checked(state);
  state = array.at(3);
  cb4.checked(state);
}
function send() {
  var txt;
  txt = input.text();
  jabberclient.sendMsg(contact, txt);
}
function sendupdate() {
  var list, msg, state, temp;
  list = List.create();
  state = cb1.checked();
  list.add(state);
  state = cb2.checked();
  list.add(state);
  state = cb3.checked();
  list.add(state);
  state = cb4.checked();
  list.add(state);
  temp = list.toarray();
  temp = temp.tostring();
  msg = "@vistascript@" + temp;
  jabberclient.sendMsg(contact, msg);
}
function signin() {
  user = Prompter.prompt("User");
  passwd= Prompter.prompt("Passwd");
  contact= Prompter.prompt("Contact");
  jabberclient.user(user);
  jabberclient.passwd(passwd);
  jabberclient.connect();
  form.text(user);
}
function signinout() {
  if (connected) {
    this.signout();
    connected = false;
    btn1.text("Signin");
  }
  else {
    this.signin();
    connected = true;
    btn1.text("Signout");
  }
}
function signout() {
  user = "";
  password = "";
  contact = "";
  form.text(user);
  jabberclient.close();
}
}
class YahooSearch extends Demo {
var resultarray, searchbtn, searchtext, server, summarytext, titlelist;
static function open() {
  var ys;
  ys = new YahooSearch();
  ys.open();
}
function load() {
  var hnd;
  hnd = function(){this.search();};
  Handler.addHandler(searchbtn,"Click",hnd);
  hnd = function(){this.titleselected();};
  Handler.addHandler(titlelist,"SelectedIndexChanged",hnd);
  server = Vs2Php.create();
  server.url("http://api.search.yahoo.com/WebSearchService/V1/webSearch");
}
function open() {
  var hnd;
  super.open("Scripts/Xml/yahoosearch.xml");
  searchbtn = Vm.findControlName(form, "searchButton");
  searchtext = Vm.findControlName(form, "searchText");
  summarytext = Vm.findControlName(form, "summaryText");
  titlelist = Vm.findControlName(form, "titleList");
  hnd = function(){this.load();};
  Handler.addHandler(form,"Load",hnd);
  super.run();
}
function search() {
  var response, resultset, query, searchterm;
  query = "appid=vistascriptdemo&output=php&results=100&query=";
  searchterm = searchtext.text();
  response = server.queryServer(query + searchterm);
  resultset=response.at("ResultSet");
  resultarray=resultset.at("Result");
  this.showtitles();
}
function showtitles() {
  var i, len, r, title;
  items = titlelist.items();
  items.clear();
  len = resultarray.length();
  i = 0;
  while(i < len) {
    title = "* no title *";
    r = resultarray.at(i);
    if (r.notnil()) {
      title = r.at("Title");
    }
    items.add(title);
    i = i + 1;
  }
}
function titleselected() {
  var index, summary, values;
  index = titlelist.selectedindex();
  summary = "* no summary *";
  values = resultarray.at(index);
  if (values.notnil()) {
    summary = values.at("Summary");
    if (summary.isnil()) {
      summary = "* no summary *";
    }
  }
  summarytext.text("Summary: " + summary);
}
}
class Inspector extends Window {
}
class IndexedInspector extends Inspector {
var list, listbox, textbox;
static function open(list) {
  var w;
  w = new IndexedInspector();
  w.open(list);
}
function load(list) {
  var i=0,items,len;
  items = listbox.items();
  items.clear();
  len=list.length();
  while(i<len) {
    items.add(i);
    i=i+1;
  }
}
function open(lst) {
  var hnd;
  list=lst;
  super.open("Scripts/Xml/indexedinspector.xml");
  listbox = Vm.findControlName(form, "listbox");
  textbox = Vm.findControlName(form, "textbox");
  hnd = function(){this.load(lst);};
  Handler.addHandler(form,"Load",hnd);
  hnd = function(){this.select();};
  Handler.addHandler(listbox,"SelectedIndexChanged",hnd);
  super.run();
}
function select() {
  var index,item;
  index=listbox.selectedindex();
  item=list.at(index);
  textbox.text(item.tostring());
}
}
class ArrayInspector extends IndexedInspector {
static function open(list) {
  var w;
  w = new ArrayInspector();
  w.open(list);
}
function title() {
  return "Array Inspector";
}
}
class DictionaryInspector extends IndexedInspector {
static function open(dict) {
  var w;
  w = new DictionaryInspector();
  w.open(dict);
}
function load(dict) {
  var i=0,items,keys,len;
  keys=dict.keys();
  items = listbox.items();
  items.clear();
  len=keys.length();
  while(i<len) {
    items.add(keys.at(i));
    i=i+1;
  }
}
function select() {
  var key,value;
  key=listbox.selecteditem();
  value=list.at(key);
  textbox.text(value.tostring());
}
function title() {
  return "Dictionary Inspector";
}
}
class ListInspector extends IndexedInspector {
static function open(list) {
  var w;
  w = new ListInspector();
  w.open(list);
}
function title() {
  return "List Inspector";
}
}
class StringInspector extends Inspector {
static function open(txt) {
  var w;
  w = new StringInspector();
  w.open(txt);
}
function load(txt) {
  Console.println(txt);
}
function open(txt) {
  var hnd;
  super.open("Scripts/Xml/stringinspector.xml");
  hnd = function(){this.load(txt);};
  Handler.addHandler(form,"Load",hnd);
  super.run();
}
function setTitle() {
}
}
